import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.*;

/**
 * Created by evgeny on 13.05.15.
 */
public class couriers_ez_brute {
    TreeSet<Courier> freeCouriers1 = new TreeSet<>((Courier a, Courier b) -> {
        int x = a.position - b.position;
        if (x == 0)
            return a.nmb - b.nmb;
        return x;
    });
    TreeSet<Courier> freeCouriers2 = new TreeSet<>((Courier a, Courier b) -> {
        int x = a.position - b.position;
        if (x == 0)
            return -a.nmb + b.nmb;
        return x;
    });

    TreeSet<Courier> busyCouriers = new TreeSet<>((Courier a, Courier b) -> {
        int x = a.freeTime - b.freeTime;
        if (x == 0)
            return a.nmb - b.nmb;
        return x;
    });

    List<Integer> fast(int n, int len, int[] positions, int m, int[] tm, int[] xs) {
        for (int i = 0; i < n; i++) {
            int t = positions[i];
            freeCouriers1.add(new Courier(i, t-1));
            freeCouriers2.add(new Courier(i, t-1));
        }
        SegmentTree treeL = new SegmentTree(len, (a, b)->{
            if (a == null)
                return 1;
            if (b == null)
                return -1;
            int x = a.freeTime - a.position;
            int y = b.freeTime - b.position;
            if (x == y)
                return a.nmb - b.nmb;
            return x - y;
        });
        SegmentTree treeR = new SegmentTree(len, (a, b)->{
            if (a == null)
                return 1;
            if (b == null)
                return -1;
            int x = a.freeTime + a.position;
            int y = b.freeTime + b.position;
            if (x == y)
                return a.nmb - b.nmb;
            return x - y;
        });
        int cnt = 0;
        List<Integer> ans = new ArrayList<>();
        while (m --> 0) {
            int time = tm[cnt];
            int pos = xs[cnt++]-1;
            Courier c;
            while (busyCouriers.size() > 0 && (c = busyCouriers.first()).freeTime <= time) {
                busyCouriers.remove(c);
                treeL.removeFrom(c);
                treeR.removeFrom(c);
                c.freeTime = -1;
                freeCouriers1.add(c);
                freeCouriers2.add(c);
            }
            Courier tmp = new Courier(-1, pos);
            Courier cc = freeCouriers1.ceiling(tmp);
            Courier cf = freeCouriers2.floor(tmp);

            Courier cl = treeL.getBest(0, pos);
            Courier cr = treeR.getBest(pos, len-1);
            c = getBest(time, pos, cc, cf, cl, cr);
            freeCouriers1.remove(c);
            freeCouriers2.remove(c);

            busyCouriers.remove(c);
            treeL.removeFrom(c);
            treeR.removeFrom(c);
            c.freeTime = Math.abs(c.position - pos) + (c.freeTime == -1 ? time : c.freeTime);
            c.position = pos;
            busyCouriers.add(c);
            treeL.addTo(c);
            treeR.addTo(c);
            ans.add(c.nmb + 1);
        }
        return ans;
    }

    static Courier getBest(int time, int pos, Courier... c) {
        int ans = 1000000000;
        int cans = -1;
        int y = -1;
        for (int i = 0; i < c.length; i++) {
            if (c[i] == null)
                continue;
            int now = Math.max(time, c[i].freeTime) + Math.abs(pos - c[i].position);
            if (now < ans || (now == ans && cans > c[i].nmb)) {
                ans = now;
                cans = c[i].nmb;
                y = i;
            }
        }
        return c[y];
    }

    List<Integer> brute(int n, int len, int[] positions, int m, int[] tm, int[] xs) {
        List<Courier> couriers = new ArrayList<>();
        List<Integer> ans = new ArrayList<>();
        for (int i = 0; i < n; i++)
            couriers.add(new Courier(i, positions[i]));
        for (int it = 0; it < m; it++) {
            int time = tm[it];
            int x = xs[it];
            Courier cur = null;
            for (Courier c : couriers) {
                if (c.freeTime <= time)
                    c.freeTime = -1;
                cur = getBest(time, x, cur, c);
            }
            cur.freeTime = Math.abs(cur.position - x) + (cur.freeTime == -1 ? time : cur.freeTime);
            cur.position = x;
            ans.add(cur.nmb+1);
        }
        return ans;
    }

    static void printTest(int n, int len, int[] positions, int m, int[] tm, int[] xs) throws FileNotFoundException {
        PrintWriter wa = new PrintWriter(new File("wa.out"));
        wa.println(n + " " + len);
        for (int i = 0; i < positions.length; i++)
            wa.print(positions[i] + " ");
        wa.println();
        wa.println(m);
        for (int i = 0; i < m; i++) {
            wa.println(tm[i] + " " + xs[i]);
        }
        wa.close();
    }

    public static void main(String[] args) throws FileNotFoundException {
        //check();
        //if (true)return;
        Scanner in = new Scanner(new File("couriers.in"));
        PrintWriter out = new PrintWriter(new File("couriers.out"));
        int n = in.nextInt();
        int len = in.nextInt();
        int[] pos = new int[n];
        for (int i = 0; i < n; i++) {
            pos[i] = in.nextInt();
        }
        int m = in.nextInt();
        int[] tm = new int[m];
        int[] xs = new int[m];
        int c = 0;
        while (c < m) {
            int time = in.nextInt();
            int ps = in.nextInt();
            tm[c] = time;
            xs[c] = ps;
            c++;
        }
        List<Integer> fst = new couriers_ez_brute().brute(n, len, pos, m, tm, xs);
        fst.stream().forEach(out::println);
        out.close();
    }



    static void check() throws FileNotFoundException {
        Random rnd = new Random();
        int N = 100;
        int LEN = 1000;
        int M = 1000;
        int TIME = 100;
        for (; ;) {
            int n = rnd.nextInt(N) + 1;
            int len = rnd.nextInt(LEN) + 1;
            int[] pos = new int[n];
            for (int i = 0; i < n; i++)
                pos[i] = rnd.nextInt(len) + 1;
            int m = rnd.nextInt(M);
            int[] tm = new int[m];
            int[] xs = new int[m];
            for (int i = 0; i < m; i++) {
                tm[i] = rnd.nextInt(TIME);
                xs[i] = rnd.nextInt(len) + 1;
            }
            Arrays.sort(tm);
            printTest(n, len, pos, m, tm, xs);
            couriers_ez_brute runner = new couriers_ez_brute();
            List<Integer> fst = runner.fast(n, len, pos, m, tm, xs);
            List<Integer> brt = runner.brute(n, len, pos, m, tm, xs);
            if (!fst.equals(brt)) {
                System.out.println("FAST: " + fst);
                System.out.println("BRUTE: " + brt);
                break;
            }
            System.out.println("OK");
        }
    }

    private static class Courier {
        int position;
        int freeTime;
        int nmb;
        Courier(int nmb, int pos) {
            this.nmb = nmb;
            this.position = pos;
            freeTime = -1;
        }
    }

    private static class SegmentTree {
        Node[] tree;
        Comparator<Courier> c;
        int n;

        SegmentTree(int n, Comparator<Courier> c) {
            this.n = n;
            tree = new Node[4 * n];
            this.c = c;
            build(1, 0, n);
        }

        void build (int v, int l, int r) {
            tree[v] = new Node(l, r);
            if (r - l == 1)
                return;
            int m = (l + r) / 2;
            build (2 * v, l, m);
            build (2 * v + 1, m, r);
        }

        Courier getBest(int l, int r) {
            if (r < l)
                return null;
            return getBest(1, l, r + 1);
        }

        private Courier getBest(int v, int l, int r) {
            if (tree[v].l >= r || tree[v].r <= l)
                return null;
            if (tree[v].l >= l && tree[v].r <= r)
                return tree[v].best;
            Courier a = getBest(2 * v, l, r);
            Courier b = getBest(2 * v + 1, l, r);
            return c.compare(a, b) > 0 ? b : a;
        }

        void removeFrom(Courier c) {
            removeFrom(1, c.position, c);
        }

        private void removeFrom(int v, int pos, Courier c) {
            if (tree[v].l > pos || tree[v].r <= pos)
                return;
            if (tree[v].l == pos && tree[v].r == pos + 1) {
                tree[v].set.remove(c);
                tree[v].best = tree[v].set.size() == 0 ? null : tree[v].set.first();
                return;
            }
            removeFrom(2 * v, pos, c);
            removeFrom(2 * v+1, pos, c);
            Courier a = tree[2 * v].best;
            Courier b = tree[2 * v + 1].best;
            tree[v].best = this.c.compare(a, b) > 0 ? b : a;
        }

        void addTo(Courier c) {
            addTo(1, c.position, c);
        }

        private void addTo(int v, int pos, Courier c) {
            if (tree[v].l > pos || tree[v].r <= pos)
                return;
            if (tree[v].l == pos && tree[v].r == pos + 1) {
                tree[v].set.add(c);
                tree[v].best = tree[v].set.first();
                return;
            }
            addTo(2 * v, pos, c);
            addTo(2 * v + 1, pos, c);
            Courier a = tree[2 * v].best;
            Courier b = tree[2 * v + 1].best;
            tree[v].best = this.c.compare(a, b) > 0 ? b : a;
        }


        private class Node {
            int l, r;
            Courier best = null;
            TreeSet<Courier> set;
            Node(int l, int r) {
                this.l = l;
                this.r = r;
                if (r - l == 1)
                    set = new TreeSet<Courier>(c);
            }
        }
    }
}
