import java.io.*;
import java.util.*;




public class TestGen {
    
    static PrintWriter out;
    static Random rnd = new Random(0);
    static int tNumber;
    
    static void printTest(int n, int len, int[] p, int m, int[] t, int[] x) throws IOException {
        if (tNumber < 10)
            out = new PrintWriter("../tests/0" + tNumber);
        else
            out = new PrintWriter("../tests/" + tNumber);
        tNumber++;
        out.println(n + " " + len);
        for (int i = 0; i < n; i++)
            out.print(p[i] + (i == n - 1 ? "" : " "));
        out.println();
        out.println(m);
        for (int i = 0; i < m; i++)
            out.println(t[i] + " " + x[i]);
        out.close();
    }
    
    static void genSample() throws FileNotFoundException {
        out = new PrintWriter("../tests/01");               
        out.println("3 10");
        out.println("1 5 10");
        out.println("5");
        out.println("1 7");
        out.println("2 4");
        out.println("5 10");
        out.println("6 1");
        out.println("7 7");
        out.close();           
    }
    
    static int randFromTo(int l, int r) {
        return rnd.nextInt(r - l + 1) + l;      
    }
    
    static void printRandomTest(int minN, int maxN, int minLEN, int maxLEN, int M, int minTIME, int maxTIME) 
    throws IOException {
        int n = randFromTo(minN, maxN);
        int len = randFromTo(minLEN, maxLEN);
        int[] pos = new int[n];
        for (int i = 0; i < n; i++)
            pos[i] = rnd.nextInt(len) + 1;
        int m = M;
        int[] tm = new int[m];
        int[] xs = new int[m];
        for (int i = 0; i < m; i++) {
            tm[i] = randFromTo(minTIME, maxTIME);
            xs[i] = rnd.nextInt(len) + 1;
        }
        Arrays.sort(tm);
        printTest(n, len, pos, m, tm, xs);
    }

    static void printAllAtOneTest(int minN, int maxN, int minLEN, int maxLEN, int M, int minTIME, int maxTIME) 
    throws IOException {
        int n = randFromTo(minN, maxN);
        int len = randFromTo(minLEN, maxLEN);
        int[] pos = new int[n];
        for (int i = 0; i < n; i++)
            pos[i] = rnd.nextInt(len) + 1;
        int m = M;
        int[] tm = new int[m];
        int[] xs = new int[m];
        for (int i = 0; i < m; i++) {
            tm[i] = randFromTo(minTIME, maxTIME);
            xs[i] = (1 + len) / 2;
        }
        Arrays.sort(tm);
        printTest(n, len, pos, m, tm, xs);
    }

    public static void main(String[] args) throws IOException {
        genSample();
        tNumber = 2;
        for (int i = 0; i < 5; i++) {
            printRandomTest(5, 10, 5, 10, 20, 0, 15);    
        }
        for (int i = 0; i < 2; i++) {
            printRandomTest(100, 150, 10, 20, 1000, 0, 100);    
        }
        for (int i = 0; i < 5; i++) {
            printRandomTest(100, 150, 100, 150, 1000, 0, 1000);    
        }
        for (int i = 0; i < 5; i++) {
            printRandomTest(1000, 1500, 100, 150, 10000, 0, 1000);    
        }
        for (int i = 0; i < 5; i++) {
            printRandomTest(1000, 1500, 1000, 1500, 10000, 0, 1000);    
        }
        for (int i = 0; i < 5; i++) {
            printRandomTest(1000, 1500, 100, 150, 100000, 0, 100);    
        }
        for (int i = 0; i < 5; i++) {
            printRandomTest(100000, 100000, 100, 150, 100000, 0, 100);    
        }
        {
        	int n = 10;
            int len = 100000;
            int[] pos = new int[n];
            for (int i = 0; i < n; i++)
                pos[i] = rnd.nextInt(100) + 1;
            int m = 100000;
            int[] tm = new int[m];
            int[] xs = new int[m];
            for (int i = 0; i < m; i++) {
                tm[i] = randFromTo(1, 1000);
                if (i % 2 == 0) 
	                xs[i] = rnd.nextInt(100) + 1;
	            else 
	                xs[i] = randFromTo(100000 - 100, 100000);
            }
            Arrays.sort(tm);
            printTest(n, len, pos, m, tm, xs);	

        }
        for (int i = 0; i < 5; i++) {
            printRandomTest(100000, 100000, 100, 150, 100000, 10000, 100000);    
        }
        for (int i = 0; i < 5; i++) {
            printRandomTest(100000, 100000, 100000, 100000, 100000, 10, 100);    
        }
        for (int i = 0; i < 5; i++) {
            printRandomTest(100000, 100000, 100000, 100000, 100000, 10000, 100000);    
        }
        printRandomTest(100000, 100000, 1, 1, 100000, 10000, 100000);    
        printAllAtOneTest(100000, 100000, 100000, 100000, 100000, 10000, 100000);    
    }
}
