import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import static ru.ifmo.testlib.Outcome.Type.*;

import java.util.ArrayList;
import java.util.Arrays;

public class Check implements Checker {
    public Outcome outcome(Outcome.Type type, final String format, final Object... args) {
        return new Outcome(type, String.format(format, args));
    }

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        ArrayList<Integer> jAns = new ArrayList<>();
        while (true) {
            try {
                int x = ans.nextInt();
                jAns.add(x);
            } catch (Throwable e) {
                break;
            }
        }
        int n = jAns.size();
        for (int i = 0; i < n; i++) {
            int pAns = ouf.nextInt();
            if (pAns != jAns.get(i)) {
                return outcome(WA, "" + (i + 1) + "-th query: expected " + jAns.get(i) + ", but found " + pAns);
            }
        }
        return outcome(OK, "Corrent answer, " + n + " numbers");
    }
}
