#include <cstdio>
#include <vector>
#include <map>

using namespace std;

const int MOD = (int)(1e9) + 7;
const int INF = 2e9;

int bin(int x, int n, int MOD) {
    if (n == 0) return 1 % MOD;
    int res = bin(x, n / 2, MOD);
    res = 1LL * res * res % MOD;
    if (n % 2 == 1) res = 1LL * res * x % MOD;
    return res;
}

pair<int, int> calc(int len, int MOD) {
    if (len == 1) {
        return make_pair(1 % MOD, 10 % MOD);
    }
    pair<int, int> res = calc(len / 2, MOD);
    res.first = (1LL * res.first * res.second + res.first) % MOD;
    res.second = 1LL * res.second * res.second % MOD;
    if (len % 2 == 1) {
        res.first = (10LL * res.first + 1) % MOD;
        res.second = 10LL * res.second % MOD;
    }
    return res;
}

bool ok(int k, int len) {
    return calc(len, k).first == 0;
}

void rec(vector<pair<int, int> > &a, int &mn, int n, int cur, int k) {
    if (n == a.size()) {
        if (ok(k, cur)) {
            mn = min(mn, cur);
        }
        return;
    }
    for (int i = 0; i <= a[n].second; i++) {
        rec(a, mn, n + 1, cur, k);
        cur *= a[n].first;
    }
}

int main() {
    freopen("numbers.in", "r", stdin);
    freopen("numbers.out", "w", stdout);

    const int MX = 32000;
    vector<int> pr;
    vector<char> isPrime(MX, 1);
    for (int i = 2; i < MX; i++) {
        if (!isPrime[i]) continue;
        pr.push_back(i);
        for (int j = i + i; j < MX; j += i) isPrime[j] = 0;
    }

    map<int, int> mp;

    int T;
    scanf("%d", &T);
    while (T--) {
        int k;
        scanf("%d", &k);
        if (k <= 10) {
            printf("%d\n", 1);
            continue;
        }
        if (mp.count(k)) {
            printf("%d\n", mp[k]);
            continue;
        }
        int x = k - 1;
        int mn = INF;
        vector<pair<int, int> > a;
        for (int i = 0; i < (int)pr.size() && pr[i] * pr[i] <= x; i++) {
            if (x % pr[i] == 0) {
                int cnt = 0;
                while (x % pr[i] == 0) {
                    x /= pr[i];
                    cnt++;
                }
                a.push_back(make_pair(pr[i], cnt));
            }
        }
        if (x > 1) a.push_back(make_pair(x, 1));
        rec(a, mn, 0, 1, k);
        if (mn == INF) mp[k] = -1;
        else mp[k] = (int)(1LL * calc(mn, MOD).first * bin(k, MOD - 2, MOD) % MOD);
        printf("%d\n", mp[k]);
    }

    return 0;
}