#include <cstdio>
#include <vector>

using namespace std;

const int MOD = (int)(1e9) + 7;
const int INF = 2e9;

int bin(int x, int n, int MOD) {
    if (n == 0) return 1 % MOD;
    int res = bin(x, n / 2, MOD);
    res = 1LL * res * res % MOD;
    if (n % 2 == 1) res = 1LL * res * x % MOD;
    return res;
}

pair<int, int> calc(int len, int MOD) {
    if (len == 1) {
        return make_pair(1 % MOD, 10 % MOD);
    }
    pair<int, int> res = calc(len / 2, MOD);
    res.first = (1LL * res.first * res.second + res.first) % MOD;
    res.second = 1LL * res.second * res.second % MOD;
    if (len % 2 == 1) {
        res.first = (10LL * res.first + 1) % MOD;
        res.second = 10LL * res.second % MOD;
    }
    return res;
}

bool ok(int k, int len) {
    return calc(len, k).first == 0;
}

int main() {
    freopen("numbers.in", "r", stdin);
    freopen("numbers.out", "w", stdout);

    int T;
    scanf("%d", &T);
    while (T--) {
        int k;
        scanf("%d", &k);
        if (k <= 10) {
            printf("%d\n", 1);
            continue;
        }
        int x = k - 1;
        int mn = k - 1;
        if (mn == INF) {
            printf("%d\n", -1);
            continue;
        }
        printf("%d\n", (int)(1LL * calc(mn, MOD).first * bin(k, MOD - 2, MOD) % MOD));
    }

    return 0;
}