import java.io.InputStreamReader;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.util.StringTokenizer;
import java.math.BigInteger;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author Vadim Semenov
 */
public class numbers_vs {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            inputStream = new FileInputStream("numbers.in");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("numbers.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Numbers solver = new Numbers();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }
}

class Numbers {
    private static final int MODULO = 1_000_000_007;

    public void solve(int testNumber, InputReader in, PrintWriter out) {
        int prime = in.nextInt();
        if (prime < 10) {
            out.println(1);
            return;
        }
        int answer = -1;
        for (int div = 1; div * div < prime; ++div) {
            if ((prime - 1) % div != 0) continue;
            if (pow(10, div, prime) == 1) {
                answer = calculate(prime, div);
                break;
            }
            if (pow(10, (prime - 1) / div, prime) == 1) {
                answer = calculate(prime, (prime - 1) / div);
            }
        }
        out.println(answer);
    }

    private int calculate(int prime, int ones) {
        int numerator = pow(10, ones);
        numerator += MODULO - 1;
        if (numerator >= MODULO) numerator -= MODULO;
        int denominator = 9;
        long result = numerator * 1L * inverse(denominator);
        result %= MODULO;
        result *= inverse(prime);
        result %= MODULO;
        return (int) result;
    }

    private int pow(long base, int power) {
        return pow(base, power, MODULO);
    }

    private int pow(long base, int power, int mod) {
        long result = 1;
        while (power > 0) {
            if ((power & 1) == 1) {
                result = (result * base) % mod;
            }
            base = (base * base) % mod;
            power >>>= 1;
        }
        return (int) result;
    }

    private int inverse(int number) {
        return pow(number, MODULO - 2);
    }
}

class InputReader {
    private final BufferedReader reader;
    private StringTokenizer tokenizer;

    public InputReader(InputStream in) {
        reader = new BufferedReader(new InputStreamReader(in));
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(readLine());
        }
        return tokenizer.nextToken();
    }

    public String readLine() {
        String line;
        try {
            line = reader.readLine();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        return line;
    }
}