import random
import math
random.seed("basic05")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([1, 2])
        self.print_test([1, 2, 5])

    def generate_min_tests(self):
        self.print_test([1])
        self.print_test([1, 10])
        self.print_test([2, 23])
        self.print_test([2, 3])
        self.print_test([1, 23])
        self.print_test([2, 32])
        self.print_test([1, 10])
        self.print_test([12, 100])
        self.print_test([1, 2, 34, 123, 2467, 70981])
    
    def generate_hand_tests(self):
        pass        
        
    def randomGreater(self, x):
        return x + random.randint(1, 10*980)

    def generate_random_test(self, maxn):
        n = random.randint(1, maxn)
        nums = [0 for i in range(n)]
        x = 0
        for i in range(n):
            nums[i] = self.randomGreater(x)
            x = nums[i]
        self.print_test(nums)

    def generate_max_tests(self, maxn):
        n = maxn
        nums = [0 for i in range(n)]
        nums[0] = 9
        for i in range(1, n):
            nums[i] = ("9" * (i + 1))
        self.print_test(nums)

        n = maxn
        nums = [0 for i in range(n)]
        nums[0] = random.randint(1, 8)
        for i in range(1, n):
            nums[i] = ("9" * i) + str(random.randint(1, 8))
        self.print_test(nums)

        n = maxn
        nums = [0 for i in range(n)]
        nums[0] = random.randint(1, 8)
        for i in range(1, n):
            nums[i] = ("9" * i)
            digit = int(nums[i - 1]) % 10 - 1
            if digit < 0:
                digit = 9
            nums[i] += str(digit)
        self.print_test(nums)
    
    def print_test(self, a):
        self.test_number += 1
        print('Generating test #' + str(self.test_number))
        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(a), file=test_file)
        print(' '.join(str(element) for element in a), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        maxn = 1000

        self.generate_samples()
        self.generate_hand_tests()
        self.generate_min_tests()

        for i in range(10):
            self.generate_random_test(10)
        for i in range(10):
            self.generate_random_test(100)
        for i in range(10):
            self.generate_random_test(maxn)
        self.generate_max_tests(maxn)        

import os, shutil
if os.path.exists('../tests'):
    print('Directory tests is already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)