/**
 * Created by pva701 on 12.03.2015.
 */

import ru.ifmo.testlib.*;
import ru.ifmo.testlib.Outcome.Type;

public class Check implements Checker {

    static void ensure(boolean b, String message) {
        if (!b) {
            throw new AssertionError(message);
        }
    }

    void ensureLimits(long n, long from, long to, String name) {
        ensure(from <= n && n <= to, name + " must be from " + from + " to " + to);
    }

    public Outcome checkSolution(int[] a, int[] b, InStream in) {
        int n = a.length;
        int[] c = new int[n];
        System.arraycopy(a, 0, c, 0, n);
        int k = in.nextInt();
        ensureLimits(k, 0, n, "Too much transformations!");
        in.nextLine();
        for (int i = 0; i < k; ++i) {
            int x = in.nextInt();
            int y = in.nextInt();
            in.nextLine();
            ensureLimits(x, 1, n, "Wrong index = " + x);
            ensureLimits(y, 1, n, "Wrong index = " + y);
            --x;
            --y;
            if (c[y] > c[x]) c[x] = c[y];
        }
        for (int i = 0; i < n; ++i)
            if (b[i] != c[i])
                return new Outcome(Type.WA, "Incorrect answer!");
        return new Outcome(Type.OK, "Correct solution!");
    }

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        String hasAnsJury = ans.nextToken().toLowerCase();
        String hasAnsPart = ouf.nextToken().toLowerCase();
        if (!hasAnsPart.equals("yes") && !hasAnsPart.equals("no")) {
            return new Outcome(Type.PE, "Expected YES or NO, but received " + hasAnsPart);
        }
        ans.nextLine();
        ouf.nextLine();

        if (!hasAnsJury.equals(hasAnsPart))
            return new Outcome(Type.WA, "Expected " + hasAnsJury + ", but received " + hasAnsPart);
        if (hasAnsJury.equals("no")) {
            // ans.close();
            // ouf.close();
            return new Outcome(Type.OK, "Ok. No solution!");
        }

        int n = inf.nextInt();
        inf.nextLine();
        int[] a = new int[n];
        int[] b = new int[n];
        for (int i = 0; i < n; ++i) a[i] = inf.nextInt();
        inf.nextLine();
        for (int i = 0; i < n; ++i) b[i] = inf.nextInt();
        // inf.close();

        try {
            if (!checkSolution(a, b, ans).getType().equals(Type.OK))
                return new Outcome(Type.FAIL, "Jury solution is wrong!");
        } catch (AssertionError e) {
            return new Outcome(Type.FAIL, "Jury solution is wrong!");
        }
        try {
            return checkSolution(a, b, ouf);
        } catch (AssertionError e) {
            return new Outcome(Type.WA, "WA");
        }
    }
}
