/**
 * Created with IntelliJ IDEA.
 * User: User
 * Date: 20.11.14
 * Time: 1:40
 * To change this template use File | Settings | File Templates.
 */
import java.io.*;
import java.util.*;

public class TestGen {
    final int MAX_N = 100000;
    final int MAX_VAL = 1000000000;
    Random random = new Random(0xBAD);
    boolean isSamples = false;

    int testCount;
    public static class Pair {
        public int x, y;
        public Pair(int x, int y) {
            this.x = x;
            this.y = y;
        }
    }

    void print(int[] a, int[] b) throws IOException{
        List<Pair> c = new ArrayList<>();
        for (int i = 0; i < a.length; ++i)
            c.add(new Pair(a[i], b[i]));
        print(c);
    }

    void print(List<Pair> a) throws IOException {
        PrintWriter pw = new PrintWriter(String.format("../tests/%02d", ++testCount));
        System.out.println(testCount);
        if (!isSamples)
            Collections.shuffle(a, random);
        pw.println(a.size());
        for (int i = 0; i < a.size(); i++) {
            pw.print(a.get(i).x);
            if (i + 1 < a.size())
                pw.print(" ");
            else
                pw.println();
        }

        for (int i = 0; i < a.size(); i++) {
            pw.print(a.get(i).y);
            if (i + 1 < a.size())
                pw.print(" ");
            else
                pw.println();
        }
        pw.close();
    }

    void genSamples() throws IOException {
        isSamples = true;
        int[] a = new int[] {1, 1, 3};
        int[] b = new int[] {1, 3, 1};
        print(a, b);

        int[] a1 = new int[]{1, 1, 1, 3, 4};
        int[] b1 = new int[]{3, 3, 3, 4, 4};
        print(a1, b1);
        isSamples = false;
    }

    void genHandleTests() throws IOException {
    }

    int[] genDiffs(int diffs) {
        int[] ret = new int[diffs];
        for (int i = 0; i < diffs; ++i)
            ret[i] = random.nextInt(MAX_VAL) + 1;
        Arrays.sort(ret);
        return ret;
    }

    void genNONotMajor(int n) throws IOException {
        int d = random.nextInt(n) + 1;
        int[] diffs = genDiffs(d);
        int[] a = new int[n];
        int[] b = new int[n];
        for (int i = 0; i < n; ++i) {
            a[i] = diffs[random.nextInt(diffs.length)];
            b[i] = diffs[random.nextInt(diffs.length)];
        }
        print(a, b);
    }

    int[] genYesWithDiffs(int[] a, int[] b, int d) {
        int n = a.length;
        int[] diffs = genDiffs(d);
        System.arraycopy(diffs, 0, a, 0, d);
        for (int i = 0; i < n; ++i)
            if (i < d)
                b[i] = diffs[random.nextInt(d - i) + i];
            else {
                int x = random.nextInt(d);
                int y = random.nextInt(d - x) + x;
                a[i] = diffs[x];
                b[i] = diffs[y];
            }
        return diffs;
    }

    void genNOStrangeElements(int n, int d) throws IOException {
        int[] a = new int[n];
        int[] b = new int[n];
        genYesWithDiffs(a, b, d);
        int str = random.nextInt(Math.max(1, n / 10)) + 1;
        for (int i = 0; i < str; ++i) {
            int id = random.nextInt(n);
            b[id] = random.nextInt(MAX_VAL - a[id] + 1) + a[id];
        }
        print(a, b);
    }

    void genYES(int n, int d) throws IOException{
        int[] a = new int[n];
        int[] b = new int[n];
        genYesWithDiffs(a, b, d);
        print(a, b);
    }

    void genYESAllMax(int n, int d) throws IOException {
        int[] a = new int[n];
        int[] b = new int[n];
        genYesWithDiffs(a, b, d);
        int mx = 0;
        for (Integer e : a) mx = Math.max(mx, e);
        for (int i = 0; i < n; ++i) b[i] = mx;
    }

    void genYESAllEqual(int n, int d) throws IOException {
        int[] a = new int[n];
        int[] b = new int[n];
        genYesWithDiffs(a, b, d);
        System.arraycopy(a, 0, b, 0, n);
        print(a, b);
    }

    void genYESModeling(int n, int d, int it) throws IOException {
        int[] a = new int[n];
        int[] b = new int[n];
        genYesWithDiffs(a, b, d);
        System.arraycopy(a, 0, b, 0, n);
        for (int i = 0; i < it; ++i) {
            int x = random.nextInt(n);
            int y = random.nextInt(n);
            b[x] = Math.max(b[x], b[y]);
        }
        print(a, b);
    }

    void run() throws IOException {
        new File("../tests").mkdir();
        genSamples();
        genHandleTests();

        genNONotMajor(100);

        genNOStrangeElements(100, 1);
        genNOStrangeElements(100, 10);
        genNOStrangeElements(100, 5);

        genYES(100, 3);
        genYES(100, 10);
        genYES(100, 100);

        genNONotMajor(MAX_N);
        genNONotMajor(MAX_N);

        genNOStrangeElements(1, 1);
        genNOStrangeElements(MAX_N, 100);
        genNOStrangeElements(MAX_N, 1000);
        genNOStrangeElements(MAX_N, MAX_N);

        genYES(1, 1);
        genYES(2, 2);
        genYES(MAX_N, 1);
        genYES(MAX_N, 5);
        genYES(MAX_N, 10);
        genYES(MAX_N, 20);
        genYES(MAX_N, 300);
        genYES(MAX_N, 1000);
        genYES(MAX_N, MAX_N);
        genYESAllMax(MAX_N, MAX_N);
        genYESAllEqual(MAX_N, 20);
        genYESAllEqual(MAX_N, MAX_N);

        genYESModeling(MAX_N, 10, 3);
        genYESModeling(MAX_N, 100, 10);
        genYESModeling(MAX_N, 1000, 100);
        genYESModeling(MAX_N, MAX_N, 1000);
    }

    public static void main(String[] args) throws IOException {
        new TestGen().run();
    }
}

