import java.util.List;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.io.PrintStream;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.util.StringTokenizer;
import java.math.BigInteger;
import java.util.Collections;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author Vadim Semenov
 */
public class tree_vs {
	public static void main(String[] args) {
		InputStream inputStream;
		try {
			inputStream = new FileInputStream("tree.in");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("tree.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		Tree solver = new Tree();
		solver.solve(1, in, out);
		out.close();
	}
}

class Tree {
    private final Node root = new Node("");
    public void solve(int testNumber, InputReader in, PrintWriter out) {
        int counter = in.nextInt();
        int sumLength = counter;
        for (int i = 0; i < counter; ++i) {
            String path = in.next();
            sumLength += path.length();
            int begin = 0;
            Node current = root;
            while (begin < path.length()) {
                int end = begin;
                while (end < path.length() && path.charAt(end) != '/') {
                    ++end;
                }
                if (begin == end) throw new AssertionError("WTF!? " + begin);
                String directory = path.substring(begin, end);
                Node next = null;
                for (Node child : current.children) {
                    if (child.name.equals(directory)) {
                        next = child;
                    }
                }
                if (next == null) {
                    next = new Node(directory);
                    current.children.add(next);
                }
                current = next;
                begin = end + 1;
            }
        }
        System.err.println(sumLength);
        char[] prefix = new char[sumLength];
        print(out, root, prefix, 0);
    }

    private void print(PrintWriter out, Node current, char[] prefix, int ptr) {
        out.println(current.name);
        if (current != root) prefix[ptr++] = '|';
        for (int i = 0; i < current.name.length(); ++i) {
            prefix[ptr++] = '-';
        }
        String output = String.valueOf(prefix, 0, ptr);
        Collections.sort(current.children);
        for (Node child : current.children) {
            out.print(output);
            print(out, child, prefix, ptr);
        }
    }

    static class Node implements Comparable<Node> {
        final String name;
        final List<Node> children;

        Node(String name) {
            this.name = name;
            this.children = new ArrayList<>();
        }

        public int compareTo(Node that) {
            boolean same = !(this.children.size() == 0 ^ that.children.size() == 0);
            return same ?
                    name.compareTo(that.name) :
                    -Integer.compare(this.children.size(), that.children.size());
        }
    }
}

class InputReader {
    private final BufferedReader reader;
    private StringTokenizer tokenizer;

    public InputReader(InputStream in) {
        reader = new BufferedReader(new InputStreamReader(in));
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(readLine());
        }
        return tokenizer.nextToken();
    }

    public String readLine() {
        String line;
        try {
            line = reader.readLine();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        return line;
    }
}

