#include <bits/stdc++.h>
using namespace std;

struct node;

struct node
{
  map<string, node*> g;
  int depth;

  node()
    : depth(0) {}

  node* add(string const& x)
  {
    if (!g.count(x)) g[x] = new node;
    return g[x];
  }
};

vector<int> indent;
void print(string const& s)
{
  for (int x : indent) {
    cout << "|";
    for (int i = x; i--;) cout << "-";
  }
  cout << s << "\n";
}

int calcdepth(node* v)
{
  if (!v) return 0;
  for (auto const& q : v->g) {
    v->depth = max(v->depth, calcdepth(q.second) + 1);
  }
  return v->depth;
}

void dfs(node* v)
{
  if (!v) return;
  vector<pair<string, node*> > all(v->g.begin(), v->g.end());

  sort(all.begin(), all.end(), [](pair<string, node*> const& a,
                                  pair<string, node*> const& b) {
         return make_pair(a.second->depth == 0, a.first)
           < make_pair(b.second->depth == 0, b.first);
    });

  for (auto const& q : all) {
    string const& s = q.first;
    node* u = q.second;
    print(s);
    indent.push_back(s.length());
    dfs(u);
    indent.pop_back();
  }
}

int main()
{
  freopen("tree.in", "r", stdin);
  freopen("tree.out", "w", stdout);
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  string q;
  node* root = new node;

  int n;
  cin >> n;

  for (int i = 0; i < n; i++) {
    string q;
    cin >> q;
    node* cur = root;
    int last = 0;
    if (q[q.size() - 1] != '/') q += '/';
    for (int i = 0; i < (int) q.size(); i++) {
      if (q[i] == '/') {
        cur = cur->add(q.substr(last, i - last));
        last = i + 1;
      }
    }
  }

  calcdepth(root);
  dfs(root);
}
