#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int maxn = 1 << 17;

int n;
int a[maxn];
vector<int> e[maxn];
vector<pair<int, int> > dp[maxn];
                   
typedef set<int>* pset;
typedef vector<pair<int, int> >* pvector;
                   
void makeVector(pair<int, pset> o) {
    for (set<int> :: iterator it = o.second->begin(); it != o.second->end(); it++) {
        dp[o.first].push_back(make_pair(*it, 0));
    }
    dp[o.first].push_back(make_pair(n, 0));
}

void fAdd(vector<pair<int, int> > &t, int x, int y) {
    for (; x < (int)t.size(); x = x | (x + 1))
        t[x].second += y;
}

int fGet(vector<pair<int, int> > &t, int x) {
    int res = 0;
    for (; x >= 0; x = (x & (x + 1)) - 1) 
        res += t[x].second;
    return res;
}

int lg[maxn];
int fSearch(vector<pair<int, int> > &t, int value) {
    int k = lg[t.size()] + 1, o = 0, p = -1;
    for (int i = k - 1; i >= 0; i--) if (p + (1 << i) < (int)t.size() && o + t[p + (1 << i)].second > value) {
        o += t[p + (1 << i)].second;
        p += (1 << i);
    }
    return p + 1;
}

pair<int, pset> dfs1(int v, int p) {
    pset temp = new set<int>();
    temp->insert(a[v]);
    pair<int, pset> cur = make_pair(v, temp);
    for (int i = 0; i < (int)e[v].size(); i++) {
        int to = e[v][i];
        if (to == p) continue;
        pair<int, pset> o = dfs1(to, v);
        if (o.second->size() >= cur.second->size()) swap(o, cur);
        for (set<int> :: iterator it = o.second->begin(); it != o.second->end(); it++) cur.second->insert(*it);
        makeVector(o);
    }
    return cur;
}
                     
void merge(pvector a, pvector b) {
    int last = 0;
    for (int i = 0; i < (int)b->size(); i++) {
        int add = fGet(*b, i);
        int id = lower_bound(a->begin(), a->end(), make_pair((*b)[i].first + 1, -1)) - a->begin();
        fAdd(*a, last, add);
        fAdd(*a, id, -add);
        last = id;
    }
} 

bool cmp(const pair<int, int> &a, const pair<int, int> &b) {
    return a.second < b.second;
}
                     
void mergeRoot(pvector a, int x) {
    int id = lower_bound(a->begin(), a->end(), make_pair(x, -1)) - a->begin();
    int l = fSearch(*a, fGet(*a, id));
    int r = id + 1;
    fAdd(*a, l, 1);
    if (r < (int)a->size()) fAdd(*a, r, -1);
}
                     
pvector dfs2(int v, int p) {
    pvector cur = new vector<pair<int, int> >();
    for (int i = 0; i < (int)e[v].size(); i++) {
        int to = e[v][i];
        if (to == p) continue;
        pvector o = dfs2(to, v);
        if (o->size() >= cur->size()) swap(o, cur);
        merge(cur, o);
    }
    if (cur->empty()) {
        fAdd(dp[v], 0, 1);
        for (int i = 0; i < (int)dp[v].size(); i++) if (dp[v][i].first > a[v]) {
            fAdd(dp[v], i, -1);
            break;
        }
        return &dp[v];
    }
    mergeRoot(cur, a[v]);
    return cur;
}                    

int main() {
    freopen("treemin.in", "r", stdin);
    freopen("treemin.out", "w", stdout);

    lg[0] = 1;
    for (int i = 2; i < maxn; i++) lg[i] = lg[i >> 1] + 1;
    while (scanf("%d", &n) == 1) {
        for (int i = 0; i < n; i++) {
            e[i].clear();
            dp[i].clear();
        }

        vector<int> vct;
        for (int i = 0; i < n; i++) {
            scanf("%d", &a[i]);
            vct.push_back(a[i]);
        }
        sort(vct.begin(), vct.end());
        vct.resize(unique(vct.begin(), vct.end()) - vct.begin());
        for (int i = 0; i < n; i++) a[i] = lower_bound(vct.begin(), vct.end(), a[i]) - vct.begin();

        for (int i = 1; i < n; i++) {
            int u, v;
            scanf("%d%d", &u, &v);
            --u; --v;
            e[u].push_back(v);
            e[v].push_back(u);
        }

        makeVector(dfs1(0, 0));
        pvector v = dfs2(0, 0);
        printf("%d\n", n - fGet(*v, 0));
    }

    return 0;
}