#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int maxn = 1 << 17;

int n;
int a[maxn];
vector<int> e[maxn];

void merge(vector<pair<int, int> > &a, vector<pair<int, int> > &b) {
    if (a.empty()) {
        a = b;
        return;
    }
    vector<pair<int, int> > c;
    for (int i = 0; i < (int)a.size(); i++) c.push_back(make_pair(a[i].first, 0));
    for (int i = 0; i < (int)b.size(); i++) c.push_back(make_pair(b[i].first, 0));
    sort(c.begin(), c.end());
    c.resize(unique(c.begin(), c.end()) - c.begin());

    int iA = (int)a.size() - 1, iB = (int)b.size() - 1;
    for (int i = (int)c.size() - 1; i >= 0; i--) {
        while (iA - 1 >= 0 && a[iA - 1].first >= c[i].first) iA--;
        while (iB - 1 >= 0 && b[iB - 1].first >= c[i].first) iB--;
        c[i].second = a[iA].second + b[iB].second;
    } 
    a = c;
}

void mergeRoot(vector<pair<int, int> > &a, int x) {
    if (a.empty()) {
        a.push_back(make_pair(x, 1));
        a.push_back(make_pair(n, 0));
        return;
    }
    for (int i = 0; i < (int)a.size(); i++) {
        if (a[i].first >= x) {
            if (a[i].first > x) {
                a.insert(a.begin() + i, make_pair(x, 0));
                a[i].second = a[i + 1].second;
            }
            a[i].second++;
            for (int j = 0; j < i; j++) a[j].second = max(a[j].second, a[i].second);
            break;
        }
    }
}

vector<pair<int, int> > dfs(int v, int p) {
    vector<pair<int, int> > cur;
    for (int i = 0; i < (int)e[v].size(); i++) {
        int to = e[v][i];
        if (to == p) continue;
        vector<pair<int, int> > vv = dfs(to, v);
        merge(cur, vv);
    }
    mergeRoot(cur, a[v]); 
    return cur;
}

int main() {
    freopen("treemin.in", "r", stdin);
    freopen("treemin.out", "w", stdout);

    while (scanf("%d", &n) == 1) {
        for (int i = 0; i < n; i++) {
            e[i].clear();
        }

        vector<int> vct;
        for (int i = 0; i < n; i++) {
            scanf("%d", &a[i]);
            vct.push_back(a[i]);
        }
        sort(vct.begin(), vct.end());
        vct.resize(unique(vct.begin(), vct.end()) - vct.begin());
        for (int i = 0; i < n; i++) a[i] = lower_bound(vct.begin(), vct.end(), a[i]) - vct.begin();

        for (int i = 1; i < n; i++) {
            int u, v;
            scanf("%d%d", &u, &v);
            --u; --v;
            e[u].push_back(v);
            e[v].push_back(u);
        }

        vector<pair<int, int> > v = dfs(0, 0);
        printf("%d\n", n - v[0].second);
    }

    return 0;
}